#!/usr/bin/bash
#
RET=0
function has_file_correct_ownership() {
    local FILE=$1
    local USER=$2
    local GROUP=$3
    local USERID=$(id -u $USER)
    local GROUPID=$(getent group $GROUP | cut -d: -f3)
    if $SUDO_CMD [ ! -r $FILE ]; then
	    return
    fi
    if [ "$(stat -c "%u %g" $FILE)" = "$USERID $GROUPID" ]; then
            RET=1
    else
	    echo "false"
	    exit 1
    fi
}

function has_file_correct_permissions() {
    local FILE=$1
    local PERMISSIONS=$2
    if [ -e $FILE ]; then
        if [ $(stat -L -c "%a" $1) = "$PERMISSIONS" ]; then
                RET=1
        else
                echo "false"
		exit 1
        fi
    fi
}



PERMISSIONS='644'
USER='root'
GROUP='root'
FILES_PRESENT='/etc/cron.deny /etc/at.deny /etc/cron.allow /etc/at.allow'


for FILE in $FILES_PRESENT; do
     has_file_correct_ownership $FILE $USER $GROUP
     has_file_correct_permissions $FILE $PERMISSIONS
done

echo "true"
