#!/usr/bin/bash
#

function has_file_correct_ownership() {
    local FILE=$1
    local USER=$2
    local GROUP=$3
    local USERID=$(id -u $USER)
    local GROUPID=$(getent group $GROUP | cut -d: -f3)
    if [ "$(stat -c "%u %g" $FILE)" = "$USERID $GROUPID" ]; then
        return 
    else
        echo "false"
        exit 1
    fi
}

function has_file_correct_permissions() {
    local FILE=$1
    local PERMISSIONS=$2
    if [ -e $FILE ]; then
        if [ $(stat -L -c "%a" $1) = "$PERMISSIONS" ]; then
                echo "true"
        else
                echo "false"
		exit 1
        fi
    else
     	echo "false"
        exit 1   
    fi
}



FILE='/etc/gshadow-'
PERMISSIONS='640'
USER='root'
GROUP='root'

has_file_correct_ownership $FILE $USER $GROUP
has_file_correct_permissions $FILE $PERMISSIONS
