#!/usr/bin/bash

script_path=$(dirname $(readlink -f $0))
KEYPARAM=unlock_time
OLDVALUE=`bash $script_path/get_unlockValue.sh`
NEWVALUE=$1

if [ -z $1 ];then
	echo "false"
	exit
fi

CONFIG_PATH=/etc/pam.d/password-auth
TEMPVAR=`cat $CONFIG_PATH | grep "auth" | grep required | grep "pam_faillock.so"`
NEW_CONTENT=`echo $TEMPVAR | sed "s/$KEYPARAM=$OLDVALUE/$KEYPARAM=$NEWVALUE/g"`
DEFAULT_VALUE="auth required pam_faillock.so preauth audit deny=3 even_deny_root unlock_time=$1"

PATTERN=`echo $TEMPVAR | grep -o "$KEYPARAM"`
if [ -z "$PATTERN" ];then
	sed -i "/auth\s*required\s*pam_faillock\.so/d" $CONFIG_PATH
	LINE_NUMBER=""
	if [ -z "$LINE_NUMBER" ]; then
		LINE_NUMBER=$(grep -n 'auth\s*required\s*pam_genpem_sig_and_verify\.so' "$CONFIG_PATH" | cut -d: -f1)
		echo $LINE_NUMBER
	fi
	
	if [ -z "$LINE_NUMBER" ]; then
		LINE_NUMBER=$(grep -n 'auth\s*sufficient\s*pam_otpw\.so' "$CONFIG_PATH" | cut -d: -f1)
		echo $LINE_NUMBER
	fi
	
	if [ -z "$LINE_NUMBER" ]; then
		LINE_NUMBER=$(grep -n 'auth\s*sufficient\s*pam_nfsukey_verify\.so' "$CONFIG_PATH" | cut -d: -f1)
		echo $LINE_NUMBER
	fi
	
	if [ -z "$LINE_NUMBER" ]; then
		LINE_NUMBER=$(grep -n 'auth\s*sufficient\s*pam_unix\.so' "$CONFIG_PATH" | cut -d: -f1)
		echo $LINE_NUMBER
	fi
	
	if [ -n "$LINE_NUMBER" ]; then
		sed -i "${LINE_NUMBER}i $DEFAULT_VALUE" $CONFIG_PATH
	fi
	#echo "$DEFAULT_VALUE" >> $CONFIG_PATH
else
	sed -i "s/$TEMPVAR/$NEW_CONTENT/g" $CONFIG_PATH
fi

#+++++++++++++++++++++
TEMPVAR=`cat $CONFIG_PATH | grep "auth" | grep "die" | grep "pam_faillock.so"`
NEW_CONTENT=`echo $TEMPVAR | sed  "s/$KEYPARAM=$OLDVALUE/$KEYPARAM=$NEWVALUE/g"`
DEFAULT_VALUE2="auth [default=die] pam_faillock.so authfail audit deny=3 even_deny_root unlock_time=$1"

PATTERN=`echo $TEMPVAR | grep -o "$KEYPARAM"`
if [ -z "$PATTERN" ];then
	sed -i "/auth\s*pam_faillock\.so\s*authfail\s*audit/d" $CONFIG_PATH
	LINE_NUMBER_RAW=$(grep -n 'auth\s*sufficient\s*pam_unix\.so' "$CONFIG_PATH" | cut -d: -f1)
	if [ -n "$LINE_NUMBER_RAW" ]; then
		LINE_NUMBER=$((LINE_NUMBER_RAW + 1))
		sed -i "${LINE_NUMBER}i $DEFAULT_VALUE2" $CONFIG_PATH
	fi
	#echo "$DEFAULT_VALUE2" >> $CONFIG_PATH
else
	sed -i "s/$KEYPARAM=$OLDVALUE/$KEYPARAM=$NEWVALUE/g" $CONFIG_PATH
fi
