#!/usr/bin/bash

#返回0 验签,验签不过提示告警信息
#返回1 不验签
#返回2 验签，验签不过停止安装

SIGFILE="/etc/rpm/.rpm.sig"

# 检查 /etc/rpm/.rpm.sig 文件是否存在
if [ -f "${SIGFILE}" ]; then
    # 文件存在，检查 rpmsigkey= 是否存在
    if grep -q "rpmsigkey=" ${SIGFILE}; then
        # 获取 rpmsigkey 的值
        value=$(grep -oP 'rpmsigkey=\K\d+' ${SIGFILE})
        case $value in
            1)
                echo "1"
                exit 1
                ;;
            2)
                echo "2"
                exit 2
                ;;
            *)
                echo "0"
                exit 0
                ;;
        esac
    else
        echo "0"
        exit 0
    fi
else
    echo "0"
    exit 0
fi

